package eu.cloudtm.wpm.rhq.fs;

import eu.cloudtm.wpm.rhq.platform.WPMPlatformComponent;
import eu.cloudtm.wpm.rhq.registry.Registry;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.rhq.core.domain.configuration.Configuration;
import org.rhq.core.pluginapi.inventory.*;

import java.util.*;

/**
 *  File System Discovery
 *
 *  @author peluso@gsd.inesc-id.pt , peluso@dis.uniroma1.it
 */
public class FileSystemDiscovery implements ResourceDiscoveryComponent<WPMPlatformComponent>
,ManualAddFacet<WPMPlatformComponent>
{

    private final Log log = LogFactory.getLog(this.getClass());

    /**
     * This method is an empty dummy, as you have selected manual addition
     * in the plugin generator.
     * If you want to have auto discovery too, remove the "return emptySet"
     * and implement the auto discovery logic.
     */
    public Set<DiscoveredResourceDetails> discoverResources(ResourceDiscoveryContext<WPMPlatformComponent> discoveryContext) throws Exception {
        Set<DiscoveredResourceDetails> result = new HashSet<DiscoveredResourceDetails>();

        DiscoveredResourceDetails detail = null;

        String platformKey = discoveryContext.getParentResourceContext().getResourceKey();

       String mountingPoint = null;

       List<String> fsMountingPoints = Registry.getFileSystemsMountingPoints(platformKey);

       if(fsMountingPoints!=null && !fsMountingPoints.isEmpty()){
           Iterator<String> itr= fsMountingPoints.iterator();
           while(itr.hasNext()){

              mountingPoint = itr.next();

              detail = new DiscoveredResourceDetails(
                    discoveryContext.getResourceType(),

                    mountingPoint,
                    mountingPoint,
                    null,
                    null,
                    null, // can be null if no configuration
                    null);  // can be null for no process scan
              result.add(detail);


           }


       }



        return result;
        }

      /**
       * Do the manual add of this one resource
       */
      public DiscoveredResourceDetails discoverResource(Configuration pluginConfiguration, ResourceDiscoveryContext<WPMPlatformComponent> context) throws InvalidPluginConfigurationException {

            // TODO implement this
            DiscoveredResourceDetails detail = null; // new DiscoveredResourceDetails(
//                context.getResourceType(), // ResourceType
//            );

            return detail;
      }


}
