package eu.cloudtm.wpm.rhq.infinispan;

import eu.cloudtm.wpm.rhq.platform.WPMPlatformComponent;
import eu.cloudtm.wpm.rhq.registry.Registry;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.rhq.core.domain.configuration.Configuration;
import org.rhq.core.pluginapi.inventory.*;

import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

/**
 *  Infinispan Cache Discovery
 *
 *  @author peluso@gsd.inesc-id.pt , peluso@dis.uniroma1.it
 */
public class InfinispanCacheDiscovery implements ResourceDiscoveryComponent<WPMPlatformComponent>
,ManualAddFacet<WPMPlatformComponent>
{

    private final Log log = LogFactory.getLog(this.getClass());

    /**
     * This method is an empty dummy, as you have selected manual addition
     * in the plugin generator.
     * If you want to have auto discovery too, remove the "return emptySet"
     * and implement the auto discovery logic.
     */
    public Set<DiscoveredResourceDetails> discoverResources(ResourceDiscoveryContext<WPMPlatformComponent> discoveryContext) throws Exception {

        Set<DiscoveredResourceDetails> result = new HashSet<DiscoveredResourceDetails>();

        DiscoveredResourceDetails detail = null;

        String platformKey = discoveryContext.getParentResourceContext().getResourceKey();


        String cacheName = null;

       List<String> cacheNames = Registry.getCacheNames(platformKey);

       if(cacheNames!=null && !cacheNames.isEmpty()){
           Iterator<String> itr= cacheNames.iterator();
           while(itr.hasNext()){

              cacheName = itr.next();

              detail = new DiscoveredResourceDetails(
                    discoveryContext.getResourceType(),
                    "Infinispan Cache ( "+cacheName+" )",
                    "Infinispan Cache ( "+cacheName+" )",
                    null,
                    null,
                    null, // can be null if no configuration
                    null);  // can be null for no process scan
            result.add(detail);


           }


       }


        return result;


    }

      /**
       * Do the manual add of this one resource
       */
      public DiscoveredResourceDetails discoverResource(Configuration pluginConfiguration, ResourceDiscoveryContext<WPMPlatformComponent> context) throws InvalidPluginConfigurationException {

            // TODO implement this
            DiscoveredResourceDetails detail = null; // new DiscoveredResourceDetails(
//                context.getResourceType(), // ResourceType
//            );

            return detail;
      }
}
