package eu.cloudtm.wpm.rhq.infinispan;

import eu.cloudtm.wpm.rhq.manager.WPMManager;

import org.apache.log4j.Logger;
import org.rhq.core.domain.configuration.Configuration;
import org.rhq.core.domain.measurement.*;
import org.rhq.core.domain.measurement.calltime.CallTimeData;
import org.rhq.core.pluginapi.configuration.ConfigurationFacet;
import org.rhq.core.pluginapi.configuration.ConfigurationUpdateReport;
import org.rhq.core.pluginapi.inventory.*;
import org.rhq.core.pluginapi.measurement.MeasurementFacet;
import org.rhq.core.pluginapi.operation.OperationFacet;
import org.rhq.core.pluginapi.operation.OperationResult;
import org.rhq.core.pluginapi.support.SnapshotReportRequest;
import org.rhq.core.pluginapi.support.SnapshotReportResults;
import org.rhq.core.pluginapi.support.SupportFacet;

import java.util.Set;

/**
 * Date: 1/4/12
 * Time: 6:54 PM
 *
 * @author pruivo
 */
public class TopKStatsComponent implements ResourceComponent<InfinispanCacheComponent>, MeasurementFacet, OperationFacet
        , ConfigurationFacet, CreateChildResourceFacet, DeleteResourceFacet, SupportFacet {

    private static final Logger log = Logger.getLogger(TopKStatsComponent.class);

    private ResourceContext<InfinispanCacheComponent> context;

    public AvailabilityType getAvailability() {
        return AvailabilityType.UP;
    }

    public Configuration loadResourceConfiguration() throws Exception {
        // TODO supply code to load the configuration from the resource into the plugin
        return null;
    }

    public void updateResourceConfiguration(ConfigurationUpdateReport configurationUpdateReport) {
       // TODO supply code to update the passed report into the resource
    }

    public CreateResourceReport createResource(CreateResourceReport createResourceReport) {
        // TODO supply code to create a child resource

        return null; // TODO change this
    }

    public void deleteResource() throws Exception {
        // TODO supply code to delete a child resource
    }

    public void getValues(MeasurementReport report, Set<MeasurementScheduleRequest> metrics) throws Exception {
        WPMManager manager = WPMManager.getOrCreateWPMManager();

        String componentKey = this.context.getParentResourceComponent().getResourceKey();

        String platformKey = this.context.getParentResourceComponent().getPlatformKey();

        String resourceKey = this.context.getResourceKey();

        for (MeasurementScheduleRequest req : metrics) {

            if(!req.getName().equals("metric")) {
                continue;
            }

            log.debug("invoking get values in top-k component with [platform key: " + platformKey + "," +
                    "component key: " + componentKey + "," +
                    "resource key: " + resourceKey + "]");

            CallTimeData res = manager.getTopKeyData(platformKey, componentKey, req, resourceKey);

            log.debug("invocation results of " + resourceKey + " is " + res);

            if(res != null){
                report.addData(res);
            }


        }
    }

    public OperationResult invokeOperation(String s, Configuration configuration) throws InterruptedException, Exception {
        return new OperationResult();
    }

    public void start(ResourceContext<InfinispanCacheComponent> context) throws InvalidPluginConfigurationException, Exception {
         this.context = context;
    }

    public void stop() {

    }

    public SnapshotReportResults getSnapshotReport(SnapshotReportRequest snapshotReportRequest) throws Exception {
        // TODO
        return null;
    }
}
