package eu.cloudtm.wpm.rhq.infinispan;

import org.rhq.core.domain.configuration.Configuration;
import org.rhq.core.pluginapi.inventory.*;

import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

/**
 * Date: 1/4/12
 * Time: 6:43 PM
 *
 * @author pruivo
 */
public class TopKStatsDiscoveryComponent implements ResourceDiscoveryComponent<InfinispanCacheComponent>
        ,ManualAddFacet<InfinispanCacheComponent> {

    public DiscoveredResourceDetails discoverResource(Configuration configuration,
                                                      ResourceDiscoveryContext<InfinispanCacheComponent> context)
            throws InvalidPluginConfigurationException {
        return null;
    }

    public Set<DiscoveredResourceDetails> discoverResources(ResourceDiscoveryContext<InfinispanCacheComponent> context)
            throws InvalidPluginConfigurationException, Exception {
        Set<DiscoveredResourceDetails> result = new HashSet<DiscoveredResourceDetails>();

        result.add(new DiscoveredResourceDetails(
                context.getResourceType(),
                "TopKLocalRead",
                "Top Key Local Read",
                null,
                null,
                null, // can be null if no configuration
                null));  // can be null for no process scan

        result.add(new DiscoveredResourceDetails(
                context.getResourceType(),
                "TopKRemoteRead",
                "Top Key Remote Read",
                null,
                null,
                null, // can be null if no configuration
                null));  // can be null for no process scan

        result.add(new DiscoveredResourceDetails(
                context.getResourceType(),
                "TopKLocalWrite",
                "Top Key Local Write",
                null,
                null,
                null, // can be null if no configuration
                null));  // can be null for no process scan

        result.add(new DiscoveredResourceDetails(
                context.getResourceType(),
                "TopKRemoteWrite",
                "Top Key Remote Write",
                null,
                null,
                null, // can be null if no configuration
                null));  // can be null for no process scan

        result.add(new DiscoveredResourceDetails(
                context.getResourceType(),
                "TopKLocked",
                "Top Key Locked",
                null,
                null,
                null, // can be null if no configuration
                null));  // can be null for no process scan

        result.add(new DiscoveredResourceDetails(
                context.getResourceType(),
                "TopKContended",
                "Top Key Contended",
                null,
                null,
                null, // can be null if no configuration
                null));  // can be null for no process scan

        result.add(new DiscoveredResourceDetails(
                context.getResourceType(),
                "TopKFailedLock",
                "Top Key Failed Lock Acquisition",
                null,
                null,
                null, // can be null if no configuration
                null));  // can be null for no process scan


        return result;

    }
}

