package eu.cloudtm.wpm.rhq.platform;

import eu.cloudtm.wpm.rhq.registry.Registry;

import java.util.*;


import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.rhq.core.domain.configuration.Configuration;
import org.rhq.core.domain.configuration.Property;
import org.rhq.core.domain.configuration.PropertySimple;
import org.rhq.core.pluginapi.inventory.DiscoveredResourceDetails;
import org.rhq.core.pluginapi.inventory.InvalidPluginConfigurationException;
import org.rhq.core.pluginapi.inventory.ManualAddFacet;
import org.rhq.core.pluginapi.inventory.ProcessScanResult;
import org.rhq.core.pluginapi.inventory.ResourceDiscoveryComponent;
import org.rhq.core.pluginapi.inventory.ResourceDiscoveryContext;


/**
 *  WPM Platform Discovery
 *
 *  @author peluso@gsd.inesc-id.pt , peluso@dis.uniroma1.it
 */
public class WPMPlatformDiscovery implements ResourceDiscoveryComponent
,ManualAddFacet
{

    private final Log log = LogFactory.getLog(this.getClass());

    /**
     * This method is an empty dummy, as you have selected manual addition
     * in the plugin generator.
     * If you want to have auto discovery too, remove the "return emptySet"
     * and implement the auto discovery logic.
     */
    public Set<DiscoveredResourceDetails> discoverResources(ResourceDiscoveryContext discoveryContext) throws Exception {
        Set<DiscoveredResourceDetails> result = new HashSet<DiscoveredResourceDetails>();
        DiscoveredResourceDetails detail = null;
        String key = null;

       List<String> platformsKeys = Registry.getWPMPlatforms();
       if(platformsKeys!=null && !platformsKeys.isEmpty()){
           Iterator<String> itr= platformsKeys.iterator();
           while(itr.hasNext()){

              key = itr.next();

              detail = new DiscoveredResourceDetails(
                discoveryContext.getResourceType(),

                key,
                key,
                null,
                "Operating System",
                null, // can be null if no configuration
                null);  // can be null for no process scan
                result.add(detail);


           }


       }



       return result;

    }

      /**
       * Do the manual add of this one resource
       */
      public DiscoveredResourceDetails discoverResource(Configuration pluginConfiguration, ResourceDiscoveryContext context) throws InvalidPluginConfigurationException {

            // TODO implement this
            DiscoveredResourceDetails detail = null; // new DiscoveredResourceDetails(
//                context.getResourceType(), // ResourceType
//            );

            return detail;
      }
}